<?php
// No direct access.
defined('QUERA_FRAMEWORK') or die;

class Controller
{
    
    /**
    * Sign in users by userName & passWord and returns JTW
    * @param string $userName 
    * @param string $userPassWD plain password
    * @return string
    */
    function signIn(string $userName,string $userPassWD): string {
        if($this->checkSignIn($userName,$userPassWD))
            return $this->createToken('definitelyNotQueraSecretKey','{"alg":"HS256","typ":"JWT"}','{"name":"' . $userName . '","iat":' . time() . '}');
        return null;
    }


    /**
    * check whether userName & passWord are valid
    * @param string $userName 
    * @param string $userPassWD plain password
    * @return bool
    */
    function checkSignIn(string $userName,string $userPassWD): bool {
        // TODO: implement
    }

    /**
    * Register user to messenger api
    * user doesn't sign in automatically after signUp
    * @param string $userName
    * @param string $userPassWD 
    * @param string $userFirstName 
    * @param string $userLastName 
    * @param string $userEmail email 
    * @return void
    */
    function signUp(string $userName,string $userPassWD,string $userFirstName,string $userLastName,string $userEmail): void {
        // TODO: implement
    }

    /**
    * creates a json web token using HS256 algorithm without encoding secret by base64 
    * @param string $secret 
    * @param string $header 
    * @param string $payload 
    * @return string
    */
    function createToken(string $secret,string $header,string $payload): string {
        // TODO: implement
    }

    /**
    * check whether token is valid
    * @param string $secret 
    * @param string $token 
    * @return bool
    */
    function checkToken(string $secret,string $token): bool {
        // TODO: implement
    }

}